function power=calc_power(Inp,optNC,optN)

if Inp.blockorder == 1
    numScan = floor(optNC*(Inp.Q*Inp.nbla+Inp.nbln)*Inp.SOA/Inp.TR);
else
    numScan = floor(optN*Inp.Q*(Inp.nbla+Inp.nbln)*Inp.SOA/Inp.TR);
end 
    
%create stimulus sequence (time between events is SOA)
if Inp.blockorder == 1
    seqBase=ones(1,Inp.nbla)'*(1:Inp.Q);
    seqBase=seqBase(:);
    seqBase=[seqBase;zeros(Inp.nbln,1)];
else   
    seqBase=[ones(1,Inp.nbla) zeros(1,Inp.nbln)]'*(1:Inp.Q);
    seqBase=seqBase(:);
end    
seq = repmat(seqBase,optNC,1);
   
deconvMfinal = DconvMTX(seq, numScan, Inp.Q, Inp.lengthHRF, Inp.SOA, Inp.TR, Inp.dT);
Z=deconvMfinal*Inp.Hmat;

Smat = highpassFilter(numScan,Inp.order,Inp.opt);
    
if Inp.previousAuto == 1
    base = [1+Inp.rho^2, -Inp.rho, zeros(1, numScan-2)]; 
    V2 = sptoeplitz(base);
    V2(1,1) = 1;
    V2(numScan,numScan) = 1; 
    V2=1/(1-Inp.rho^2).*V2; %square of whitening matrix=inverse of error covariance matrix
else
    load('autocorr.mat')
    V2 = getv('make',myscannerxc,numScan);
end
whiteM = V2 - V2*Smat*inv(Smat'*V2*Smat)*Smat'*V2; %V(I-P)V
 
%helpM = V2*Smat;
%whiteM = V2 - helpM/(Smat'*helpM)*helpM'; %V(I-P)V
    
product=Z'*whiteM*Z;
    
t_df=size(Z,1)-size(Z,2);
sd=sqrt(1/optN)*sqrt(Inp.C*(Inp.sigmaEps2*product^(-1)+Inp.sigmaQ2*Inp.D)*Inp.C');
ncp=Inp.effectSize/sd;
    
%nctcdf is noncentral culumative t-distribution
%tinv is inverse cumulative t-distribution
power=100*(1-nctcdf(-1*tinv(Inp.alpha, t_df), t_df, ncp));
%power2=100*(1-(nctcdf(tinv(1-Inp.alpha,t_df),t_df,ncp))) %power 2 also
%works

end