%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% this function finds optimal number of cycles and optimal number of
% subjects for an interval of values for the AR1 correlation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [optNCvec optNvec] = findOptNCandNAR1loopAR1(Inp)

nrRho = floor((Inp.maxRho - Inp.minRho)/0.01+1);
optNCvec=zeros(1,nrRho);
optNvec=zeros(1,nrRho);

i=0;

for rho = Inp.minRho:0.01:Inp.maxRho;
    i=i+1;
    Inp.rho = rho;
    if (Inp.pround~=1/Inp.Q) && (Inp.TR==Inp.SOA) && (Inp.rho~=0) ... 
            && (Inp.order ==0) && (Inp.blockorder == 1) && (Inp.optcrit==1)
        [NCmin N]=findOptNCandNun(Inp);
        Inp.NCmin=max(1,floor(NCmin));
    else 
        Inp.NCmin=1;
    end
    [optNC optN] = findOptNCandNAR1(Inp);
    optNCvec(:,i) = optNC;
    optNvec(:,i) = optN;
end
