%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% this function finds optimal number of cycles and optimal number of
% subjects for an interval of values for the variance ratio of
% within-subject variance to between-subject variance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [optNCmat optNmat] = findOptNCandNAR1loopAR1VarRat(Inp)

nrVarRat = floor((Inp.maxVarRat - Inp.minVarRat)/0.1+1);
nrRho = floor((Inp.maxRho - Inp.minRho)/0.01+1);
optNCmat=zeros(nrRho,nrVarRat);
optNmat=zeros(nrRho,nrVarRat);

i=0;
for rho = Inp.minRho:0.01:Inp.maxRho;
    j=0;
    i=i+1;
    for varRat = Inp.minVarRat:0.1:Inp.maxVarRat;
        j=j+1;
        Inp.rho = rho;
        Inp.varRat = varRat;
        if (Inp.pround~=1/Inp.Q) && (Inp.TR==Inp.SOA) && (Inp.rho~=0) && ...
            (Inp.order ==0) && (Inp.blockorder == 1)&& (Inp.optcrit==1)
            [NCmin N]=findOptNCandNun(Inp);
            Inp.NCmin=max(1,floor(NCmin));
        else 
            Inp.NCmin=1;
        end
        [optNC optN] = findOptNCandNAR1(Inp);    
        optNCmat(i,j) = optNC;
        optNmat(i,j) = optN;
    end
end