%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% this function finds optimal number of cycles and optimal number of
% subjects for an interval of values for the variance ratio of
% within-subject variance to between-subject variance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [optNCvec optNvec] = findOptNCandNAR1loopVarRat(Inp)

nrVarRat = floor((Inp.maxVarRat - Inp.minVarRat)/0.1+1);
optNCvec=zeros(1,nrVarRat);
optNvec=zeros(1,nrVarRat);

i=0;
for varRat = Inp.minVarRat:0.1:Inp.maxVarRat;
    i=i+1;
    Inp.varRat = varRat;
    if (Inp.pround~=1/Inp.Q) && (Inp.TR==Inp.SOA) && (Inp.rho~=0) && ...
        (Inp.order ==0) && (Inp.blockorder == 1) && (Inp.optcrit==1)
        [NCmin N]=findOptNCandNun(Inp);
        Inp.NCmin=max(1,floor(NCmin));
    else 
        Inp.NCmin=1;
    end
    [optNC optN] = findOptNCandNAR1(Inp);    
    optNCvec(:,i) = optNC;
    optNvec(:,i) = optN;
end
