function Smat = highpassFilter(n,order,opt)
%the dct method is according to spm_dctmtx.m (SPM 5) with slight adapations
%Polydrift.m is from Kao et al (2009), see also
%http://www.stat.uga.edu/~amandal/fMRI_MATLAB.zip

%n     number of time points (number of scans)
%order order of filter
%opt   opt can be dct or legendre (method for highpass filtering)
t=0:(n-1);

Smat = zeros(size(t,2),order);
if strcmp(opt,'Discrete cosine transform')
    Smat(:,1) = sqrt(1/n);
    for r=1:order
        Smat(:,r+1) = sqrt(2/n)*cos(r*pi*(2*t+1)/(2*n));
    end
elseif strcmp(opt,'Legendre')
    Smat = Polydrift(n, order);
end