function [maxNC maxN maxMinRe] = maximinAR1(Inp,NCopt,Nopt)

NCopt = unique(NCopt);
Nopt = sort(unique(Nopt),'descend');

if Inp.blockorder == 1
    seqBase=ones(1,Inp.nbla)'*(1:Inp.Q);
    seqBase=seqBase(:);
    seqBase=[seqBase;zeros(Inp.nbln,1)];
else
    seqBase=[ones(1,Inp.nbla) zeros(1,Inp.nbln)]'*(1:Inp.Q);
    seqBase=seqBase(:);
end    
seq = repmat(seqBase,min(NCopt),1);
trCDCT = sum(diag(Inp.C*Inp.D*Inp.C'));

tr = zeros(size(NCopt,2),size(Inp.minRho:0.01:Inp.maxRho,2));
for i = 1:size(NCopt,2)
    NC = NCopt(1,i);
    N = Nopt(1,i);
    if Inp.blockorder == 1
        numScan = floor(NC*(Inp.Q*Inp.nbla+Inp.nbln)*Inp.SOA/Inp.TR);
    else
        numScan = floor(NC*Inp.Q*(Inp.nbla+Inp.nbln)*Inp.SOA/Inp.TR);
    end    
    if i~=1
        seq = [seq;repmat(seqBase,NCopt(1,i)-NCopt(1,i-1),1)];
    end    
    deconvMfinal = DconvMTX(seq, numScan, Inp.Q, Inp.lengthHRF, Inp.SOA, Inp.TR, Inp.dT);
    Z=deconvMfinal*Inp.Hmat;
    Smat = highpassFilter(numScan,Inp.order,Inp.opt);
    j = 0;
    for rho = Inp.minRho:0.01:Inp.maxRho
        j = j + 1;
        base = [1+rho^2, -rho, zeros(1, numScan-2)];
        V2 = sptoeplitz(base);
        V2(1,1) = 1;
        V2(numScan,numScan) = 1; 
        V2=1/(1-rho^2).*V2;
        helpM = V2*Smat;
        whiteM = V2 - helpM/(Smat'*helpM)*helpM'; %V(I-P)V
    
        product=Z'*whiteM*Z;
        if Inp.optcrit == 1
            tr(i,j)=(Inp.varRat*sum(diag(Inp.C*product^(-1)*Inp.C'))+trCDCT)/N;
        else
            tr(i,j) = det(Inp.varRat*Inp.C*product^(-1)*Inp.C'+Inp.C*Inp.D*Inp.C')/N;
        end
    end
end

re = repmat(min(tr,[],1),size(tr,1),1)./tr;
minRe = min(re,[],2);
[maxMinRe maxInd] = max(minRe);
maxNC = NCopt(1,maxInd);
maxN = Nopt(1,maxInd);
