function [maxNC maxN maxMinRe] = maximinAR1VarRat(Inp,NCopt,Nopt)

NCopt = unique(NCopt); %to save time
Nopt = sort(unique(Nopt),'descend'); %to save time

if Inp.blockorder == 1
    seqBase=ones(1,Inp.nbla)'*(1:Inp.Q);
    seqBase=seqBase(:);
    seqBase=[seqBase;zeros(Inp.nbln,1)];
else
    seqBase=[ones(1,Inp.nbla) zeros(1,Inp.nbln)]'*(1:Inp.Q);
    seqBase=seqBase(:);
end    
seq = repmat(seqBase,min(NCopt),1);
trCDCT = sum(diag(Inp.C*Inp.D*Inp.C'));

tr = zeros(size(NCopt,1),size(Inp.minRho:0.01:Inp.maxRho,2),size(Inp.minVarRat:0.1:Inp.maxVarRat,2));
for i = 1:size(NCopt,1)
    NC = NCopt(i);
    N = Nopt(i);
    if Inp.blockorder == 1
        numScan = floor(NC*(Inp.Q*Inp.nbla+Inp.nbln)*Inp.SOA/Inp.TR);
    else
        numScan = floor(NC*Inp.Q*(Inp.nbla+Inp.nbln)*Inp.SOA/Inp.TR);
    end 
    if (i~=1)
        %way of specifying seq is used to run program faster
        seq = [seq;repmat(seqBase,NCopt(i,1)-NCopt(i-1,1),1)];
    end   
    deconvMfinal = DconvMTX(seq, numScan, Inp.Q, Inp.lengthHRF, Inp.SOA, Inp.TR, Inp.dT);
    Z=deconvMfinal*Inp.Hmat;
    Smat = highpassFilter(numScan,Inp.order,Inp.opt);
    j = 0;
    for rho = Inp.minRho:0.01:Inp.maxRho
        j = j + 1;
        base = [1+rho^2, -rho, zeros(1, numScan-2)];
        V2 = sptoeplitz(base);
        V2(1,1) = 1;
        V2(numScan,numScan) = 1; 
        V2=1/(1-rho^2).*V2;
        helpM = V2*Smat;
        whiteM = V2 - helpM/(Smat'*helpM)*helpM'; %V(I-P)V
    
        product=Z'*whiteM*Z;
        k=0;
        for varRat = Inp.minVarRat:0.1:Inp.maxVarRat
            k=k+1;
            if Inp.optcrit == 1
                tr(i,j,k)=(varRat*sum(diag(Inp.C*product^(-1)*Inp.C'))+trCDCT)/N;
            else
                tr(i,j,k) = det(varRat*Inp.C*product^(-1)*Inp.C'+Inp.C*Inp.D*Inp.C')/N;
            end    
        end
    end
end

optEff = min(tr,[],1); %take min over rows/designs to find efficiency of optimal design for given rho and ratio
optEffMat = zeros(size(tr,1),size(tr,2),size(tr,3));
for i= 1:size(tr,1)
    optEffMat(i,:,:)=squeeze(optEff);
end
re = optEffMat./tr;
minRe = min(min(re,[],3),[],2);
[maxMinRe maxInd] = max(minRe);
maxNC = NCopt(maxInd,1);
maxN = Nopt(maxInd,1);
