function varargout = pobe(varargin)
%pobe M-file for pobe.fig
%      pobe, by itself, creates a new pobe or raises the existing
%      singleton*.
%
%      H = pobe returns the handle to a new pobe or the handle to
%      the existing singleton*.
%
%      pobe('Property','Value',...) creates a new pobe using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to pobe_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      pobe('CALLBACK') and pobe('CALLBACK',hObject,...) call the
%      local function named CALLBACK in pobe.M with the given
%      input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help pobe

% Last Modified by GUIDE v2.5 14-Aug-2013 17:12:45

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @pobe_OpeningFcn, ...
                   'gui_OutputFcn',  @pobe_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before pobe is made visible.
function pobe_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for pobe
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes pobe wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = pobe_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_calculate.
function pushbutton_calculate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(pobe);
close(findobj('type','figure','name','POBE 1.2: optimal results'));
close(findobj('type','figure','name','POBE 1.2: optimal results for autocorrelation range'));
close(findobj('type','figure','name','POBE 1.2: optimal results for variance ratio range'));
close(findobj('type','figure','name','POBE 1.2: optimal results for autocorrelation and variance ratio range'));
close(findobj('type','figure','name','POBE 1.2: maximin design for autocorrelation and variance ratio range'));

if isempty(handles) 
    warndlg('Please specify some values','Error','modal')
    return
end

%design characteristics
bla = str2double(get(handles.editTaskBlockLength,'String'));
bln = str2double(get(handles.editRestBlockLength,'String'));
Inp.TR = str2double(get(handles.editTR,'String'));
Inp.SOA = str2double(get(handles.editSOA,'String'));
Inp.Q = str2double(get(handles.editNumberStimuli,'String'));
if isnan(Inp.TR)||isnan(Inp.SOA)||isnan(bla)||isnan(bln)||isnan(Inp.Q)
    warndlg('Missing value(s) for design specification','Error','modal')
    return
end  
if rem(bla,Inp.SOA)~=0 || rem(bln,Inp.SOA)~=0
    warndlg('Block lengths need to be multiples of stimulus onset asychrony','Error','modal')
    return
end    
Inp.dT = gcd_new(Inp.TR,Inp.SOA);
Inp.runtime='none';
Inp.nbln=bln/Inp.SOA;
Inp.nbla=bla/Inp.SOA;
Inp.pround=Inp.nbla/(Inp.Q*Inp.nbla+Inp.nbln);
Inp.blockorder=get(handles.popupmenuBlockOrder,'Value'); %1=ABN,2=ANBN

%contrast matrix
valContrast = get(handles.popupmenuContrastMatrix,'Value');
switch valContrast
    case 1
        Inp.C = eye(Inp.Q);
        handles.C = Inp.C;
    case 2    
        if not(isfield(handles,'C'))
            warndlg('No contrast matrix specified','Error','modal')
            return
        else    
            Inp.C = handles.C;
        end
end


%necessary here if number of stimulus types is entered after contrast
%matrix is entered
if size(Inp.C,2)~=Inp.Q
    warndlg('Number of stimulus types is unequal to number of columns in contrast matrix','Error','modal'); 
    uicontrol(handles.popupmenuContrastMatrix);
    return
end     

%optimality criterion
Inp.optcrit = get(handles.popupmenuOpt,'Value');

%costs 
Inp.C1 = str2double(get(handles.editSubjectCosts,'String'));   
Inp.C2 = str2double(get(handles.editScannerCosts,'String'));
Inp.CT = str2double(get(handles.editTotalBudget,'String'));
if isnan(Inp.C1)||isnan(Inp.C2)||isnan(Inp.CT)
    warndlg('Missing value(s) for costs','Error','modal')
    return
end    
if Inp.C1>=Inp.CT
    warndlg('Subjects costs are higher than or equal to total study budget','Error','modal')
    return
end
Inp.costsRat=Inp.C1/(Inp.C2/3600);

%autocorrelation and variance parameter
Inp.rho = str2double(get(handles.editRho,'String'));
Inp.previousAuto = get(handles.popupmenuPreviousStudy,'Value');
Inp.minRho = str2double(get(handles.editMinRho,'String'));
Inp.maxRho = str2double(get(handles.editMaxRho,'String'));
Inp.varRat = str2double(get(handles.editVarRat,'String'));
Inp.minVarRat = str2double(get(handles.editMinVarRat,'String'));
Inp.maxVarRat = str2double(get(handles.editMaxVarRat,'String'));
val = get(handles.popupmenuRanges,'Value');
if (Inp.previousAuto == 2) && (val == 2) 
    val =3;
end    
Inp.corrRE = str2double(get(handles.editCorrRe,'String'));
corrREstate = strcmp(get(handles.editCorrRe,'Enable'),'on');

switch val
    case 1
        if isnan(Inp.rho)||isnan(Inp.varRat)
            if Inp.previousAuto == 1
                warndlg('Specifiy autocorrelation and variance parameters','Error','modal')
                return
            end    
        end
    case 2
        if isnan(Inp.minRho)||isnan(Inp.maxRho)||isnan(Inp.varRat)
            warndlg('Specifiy autocorrelation and variance parameters','Error','modal')
            return
        end
    case 3
         if isnan(Inp.minVarRat)||isnan(Inp.maxVarRat)
            warndlg('Specifiy autocorrelation and variance parameters','Error','modal')
            return
         end
         if isnan(Inp.rho) && Inp.previousAuto == 1
            warndlg('Specifiy autocorrelation and variance parameters','Error','modal')
            return
         end 
    case 4
         if isnan(Inp.rho)||isnan(Inp.minVarRat)||isnan(Inp.maxVarRat)...
                 ||isnan(Inp.minRho)||isnan(Inp.maxRho)||isnan(Inp.varRat)
            warndlg('Specifiy autocorrelation and variance parameters','Error','modal')
            return
         end
end        
if corrREstate == 1 && isnan(Inp.corrRE)
    warndlg('Specifiy autocorrelation and variance parameters','Error','modal')
    return
end
if corrREstate == 0
    Inp.corrRE = 0;
end    
Inp.D=sptoeplitz([1 repmat(Inp.corrRE,1,Inp.Q-1)]);      

nuisanceBool = get(handles.checkboxModelNuisance,'Value');
if nuisanceBool == 1
    Inp.order = str2double(get(handles.editNuisanceOrder,'String'));
    if isnan(Inp.order)
        uicontrol(handles.editNuisanceOrder)
        warndlg('Specify nuisance order','Error','modal');
        return
    end    
    Inp.opt= get(handles.popupTypeNuisance,'Value');
    if Inp.opt == 1
        Inp.opt = 'Legendre';
    else
        Inp.opt = 'Discrete cosine transform';
    end   
else
    Inp.order = 0;
    Inp.opt= 'Legendre';
end

valPower = get(handles.checkboxPower,'Value');
if valPower == 1
 if (~isfield(handles,'effectSize')|| ~isfield(handles,'wsv') || ~isfield(handles,'bsv') || ~isfield(handles,'alpha'))
    warndlg('Specifiy values in power menu','Error','modal')
    pobe_power
 end  
end
 
%calculation of HRF
valHRF = get(handles.popupmenuHRF,'Value');
handles.valHRF = valHRF;
if valHRF == 1
    Inp.lengthHRF=32; %length of HRF in seconds
    pHRF = [0.1,5,15,6,0,1,1];
    scale = 1;
    shape='twogamma';
    s = [0,32];
 else
    shape = handles.shape;
    TTP = handles.TTP;
    TTU = handles.TTU;
    ratio = handles.ratio;
    posDisp = handles.posDisp;
    negDisp = handles.negDisp;
    onset = handles.onset;
    rangeMin = handles.minRange;
    rangeMax = handles.maxRange;
    Inp.lengthHRF = rangeMax - rangeMin;
    s = [rangeMin,rangeMax];
    scale= handles.scale;
    pHRF = [0.1,TTP,TTU,ratio,onset,posDisp,negDisp];
end
%HRF is sampled over lengthHRF with frequency pHRF(1)
h = hrf(shape,pHRF(1),pHRF(2),pHRF(3),pHRF(4),pHRF(5),...
    pHRF(6),pHRF(7),s,0);
h = scale * h / max(h); % scale HRF to have a max of 1

% downsampling 
h = h(1:(Inp.dT*1/pHRF(1)):end,:);
Inp.Hmat=kron(eye(Inp.Q),h);
Inp.nrtpHRF=floor(Inp.lengthHRF/Inp.dT)+1;

val = get(handles.popupmenuRanges,'Value');
if Inp.previousAuto == 2 && val == 2
    val = 3;
end    
switch val
    case 1
        if (Inp.pround~=1/Inp.Q) && (Inp.TR==Inp.SOA) && (Inp.rho~=0) && ...
                (Inp.order ==0) && (Inp.blockorder == 1) && (Inp.optcrit == 1)
            [NCmin N]=findOptNCandNun(Inp);
            Inp.NCmin=max(1,floor(NCmin));
        else 
            Inp.NCmin=1;
        end
        %Inp.NCmin = 1;
        [optNC optN] = findOptNCandNAR1(Inp);
        if Inp.blockorder == 1
            costs = optN*Inp.C1+optN*optNC*Inp.C2/3600*(Inp.Q*bla+bln);
            time = optNC*(Inp.Q*bla+bln)/60;
        else
            costs = optN*Inp.C1+optN*optNC*Inp.C2/3600*Inp.Q*(bla+bln);
            time = optNC*Inp.Q*(bla+bln)/60;   
        end    
        valPower = get(handles.checkboxPower,'Value');
        if valPower == 1
            Inp.effectSize = handles.effectSize;
            Inp.sigmaEps2 = handles.wsv;
            Inp.sigmaQ2 = handles.bsv;
            Inp.alpha = handles.alpha;
            power = calc_power(Inp,optNC,optN);
        end    
        openfig('pobe_results')
        hObject2 = pobe_results;
        handles2 = guihandles(hObject2);
        set(handles2.textResultsSubjects,'String',int2str(optN));
        set(handles2.textResultsCycles,'String',int2str(optNC));
        set(handles2.textResultsCosts,'String',costs);
        set(handles2.textResultsTime,'String',time);
        if valPower == 1
            set(handles2.textResultsPower,'String',power);
        end
        
        %guidata(hObject2,handles2)
        guidata(hObject,handles)
    case 2
        valMMDAR1 = get(handles.checkboxMMDAR1,'Value');
        pobe_message;
        [optNC optN] = findOptNCandNAR1loopAR1(Inp);
        if valMMDAR1 == 1
            [NCmax Nmax maxMinRe] = maximinAR1(Inp,optNC,optN);
        end    
        close(pobe_message);
        openfig('pobe_results_AR1')
        hObject2 = pobe_results_AR1;
        handles2 = guihandles(hObject2);
        if valMMDAR1 == 1
            set(handles2.pushbuttonSaveMMD,'Enable','on')    
        end    
        %selects axes1 as the current axes, so that 
        %Matlab knows where to plot the data
        axes(handles2.axes1)
        
        limNrLabels = 10; %the maximum number of x- or y-labels/ticks for plots
        x = Inp.minRho:0.01:Inp.maxRho;
        y = optNC(1,:);
        [haxes,hline1,hline2]=plotyy(x,y,x,y);
        set(hline1,'Color','k')
        set(hline2,'Color','k')
        
        axes(haxes(1));
        axis([Inp.minRho Inp.maxRho optNC(1,1)-1 optNC(1,end)+1])
        if size((optNC(1,1)-1):(optNC(1,end)+1))<=limNrLabels;
            set(gca,'YTick',(optNC(1,1)-1):(optNC(1,end)+1))
        else
            betweenTickSize = ceil(((optNC(1,end)+1)-(optNC(1,1)-1)+1)/limNrLabels);
            set(gca,'YTick',(optNC(1,1)-1):betweenTickSize:(optNC(1,end)+1))
        end    
        set(gca,'XColor','k','YColor','k','FontUnits','normalized')
        xlabel('Autocorrelation parameter','Color','k','FontUnits','normalized');
        ylabel('Optimal number of cycles','Color','k','FontUnits','normalized');
        box off
        
        axes(haxes(2));
        axis([Inp.minRho Inp.maxRho optNC(1,1)-1 optNC(1,end)+1])
        set(gca,'XColor','k','YColor','k')
        ylabel('Time in minutes','Color','k','FontUnits','normalized')
        
        if Inp.blockorder == 1
            minTime = (optNC(1,1)-1)*(Inp.Q*bla+bln)/60;
            maxTime = (optNC(1,end)+1)*(Inp.Q*bla+bln)/60;
        else
            minTime = (optNC(1,1)-1)*Inp.Q*(bla+bln)/60;
            maxTime = (optNC(1,end)+1)*Inp.Q*(bla+bln)/60;
        end    
        set(gca,'XTick',[]);
        if (floor(maxTime)-ceil(minTime)+1)<=limNrLabels
            labely = ceil(minTime):1:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln))  
            else
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)))  
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        else
            betweenTickSize = ceil((floor(maxTime)-ceil(minTime)+1)/limNrLabels);
            labely = ceil(minTime):betweenTickSize:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln))
            else
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)))
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        end    
        line([Inp.minRho Inp.maxRho],[(optNC(1,end)+1) (optNC(1,end)+1)],'Color','k');
        handles2.haxes = haxes;
        axes(handles2.axes2)
        y=optN(1,:);
        plot(x,y,'k')
      
        axis([Inp.minRho Inp.maxRho optN(1,end)-1 optN(1,1)+1])
        xlabel('Autocorrelation parameter','FontUnits','normalized')
        ylabel('Optimal number of subjects','FontUnits','normalized');
        if ((optN(1,1)+1)-(optN(1,end)-1)+1)<=limNrLabels
            set(gca,'YTick',(optN(1,end)-1):1:(optN(1,1)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optN(1,1)+1)-(optN(1,end)-1)+1)/limNrLabels);
            set(gca,'YTick',(optN(1,end)-1):betweenTickSize:(optN(1,1)+1),'FontUnits','normalized')
        end  
        
        if valMMDAR1 == 1
            set(handles2.textMaxNC,'String',NCmax);
            set(handles2.textMaxN,'String',Nmax);
             if Inp.blockorder == 1
                costs =Nmax*Inp.C1+Nmax*NCmax*Inp.C2/3600*(Inp.Q*bla+bln);
                time = NCmax*(Inp.Q*bla+bln)/60;
            else
                costs = Nmax*Inp.C1+Nmax*NCmax*Inp.C2/3600*Inp.Q*(bla+bln);
                time = NCmax*Inp.Q*(bla+bln)/60;   
            end  
            set(handles2.textResultsCosts,'String',costs);
            set(handles2.textResultsTime,'String',time);
            set(handles2.textResultsMaxMinVal,'String',round(maxMinRe*10^4)/10^4);
        end  
        guidata(hObject,handles)
        %guidata(hObject2,handles2)
     case 3
        valMMDVarRat = get(handles.checkboxMMDVarRat,'Value');
        pobe_message;
        [optNC optN] = findOptNCandNAR1loopVarRat(Inp);
        if valMMDVarRat == 1
            [NCmax Nmax maxMinRe] = maximinVarRat(Inp,optNC,optN);
        end
        close(pobe_message)
        openfig('pobe_results_var')
        hObject2 = pobe_results_var;
        handles2 = guihandles(hObject2);
        
        if valMMDVarRat == 1
            set(handles2.pushbuttonSaveMMD,'Enable','on');
        end    
        %selects axes1 as the current axes, so that 
        %Matlab knows where to plot the data
        axes(handles2.axes1)
        
        limNrLabels = 10; 
        x = Inp.minVarRat:0.1:Inp.maxVarRat;
        y = optNC(1,:);
        [haxes,hline1,hline2]=plotyy(x,y,x,y);
        set(hline1,'Color','k')
        set(hline2,'Color','k')
        
        axes(haxes(1));
        axis([Inp.minVarRat Inp.maxVarRat optNC(1,1)-1 optNC(1,end)+1])
        if size((optNC(1,1)-1):(optNC(1,end)+1))<=limNrLabels;
            set(gca,'YTick',(optNC(1,1)-1):(optNC(1,end)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optNC(1,end)+1)-(optNC(1,1)-1)+1)/limNrLabels);
            set(gca,'YTick',(optNC(1,1)-1):betweenTickSize:(optNC(1,end)+1),'FontUnits','normalized')
        end    
        set(gca,'XColor','k','YColor','k')
        xlabel('Variance ratio','Color','k','FontUnits','normalized');
        ylabel('Optimal number of cycles','Color','k','FontUnits','normalized');
        box off
        
        axes(haxes(2));
        axis([Inp.minVarRat Inp.maxVarRat optNC(1,1)-1 optNC(1,end)+1])
        set(gca,'XColor','k','YColor','k','FontUnits','normalized')
        ylabel('Time in minutes','Color','k','FontUnits','normalized')
        
        if Inp.blockorder == 1 
            minTime = (optNC(1,1)-1)*(Inp.Q*bla+bln)/60;
            maxTime = (optNC(1,end)+1)*(Inp.Q*bla+bln)/60;
        else
            minTime = (optNC(1,1)-1)*Inp.Q*(bla+bln)/60;
            maxTime = (optNC(1,end)+1)*Inp.Q*(bla+bln)/60;
        end
        
        set(gca,'XTick',[],'FontUnits','normalized');
        if (floor(maxTime)-ceil(minTime)+1)<limNrLabels
            labely = ceil(minTime):1:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln),'FontUnits','normalized')
            else
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)),'FontUnits','normalized')
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        else
            betweenTickSize = ceil((floor(maxTime)-ceil(minTime)+1)/limNrLabels);
            labely = ceil(minTime):betweenTickSize:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln),'FontUnits','normalized')
            else    
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)),'FontUnits','normalized')
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        end    
        line([Inp.minVarRat Inp.maxVarRat],[(optNC(1,end)+1) (optNC(1,end)+1)]);

        axes(handles2.axes2)
        y=optN(1,:);
        plot(x,y,'k')
        axis([Inp.minVarRat Inp.maxVarRat optN(1,end)-1 optN(1,1)+1])
        xlabel('Variance ratio','FontUnits','normalized')
        ylabel('Optimal number of subjects','FontUnits','normalized');
        if ((optN(1,1)+1)-(optN(1,end)-1)+1)<=limNrLabels
            set(gca,'YTick',(optN(1,end)-1):1:(optN(1,1)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optN(1,1)+1)-(optN(1,end)-1)+1)/limNrLabels);
            set(gca,'YTick',(optN(1,end)-1):betweenTickSize:(optN(1,1)+1),'FontUnits','normalized')
        end   
        
        if valMMDVarRat == 1
            set(handles2.textMaxNC,'String',NCmax);
            set(handles2.textMaxN,'String',Nmax);
            if Inp.blockorder == 1
                costs =Nmax*Inp.C1+Nmax*NCmax*Inp.C2/3600*(Inp.Q*bla+bln);
                time = NCmax*(Inp.Q*bla+bln)/60;
            else
                costs = Nmax*Inp.C1+Nmax*NCmax*Inp.C2/3600*Inp.Q*(bla+bln);
                time = NCmax*Inp.Q*(bla+bln)/60;   
            end  
            set(handles2.textResultsCosts,'String',costs);
            set(handles2.textResultsTime,'String',time);
            set(handles2.textResultsMaxMinVal,'String',round(maxMinRe*10^4)/10^4);
        end  
        guidata(hObject,handles)
    case 4
        valMMDAR1 = get(handles.checkboxMMDAR1,'Value');
        valMMDVarRat = get(handles.checkboxMMDVarRat,'Value');
        pobe_message;
        [optNCAR1loop optNAR1loop] = findOptNCandNAR1loopAR1(Inp);
        [optNCVarRatloop optNVarRatloop] = findOptNCandNAR1loopVarRat(Inp);
        
        if valMMDAR1 == 1
            [NCmaxAR1 NmaxAR1 maxMinReAR1] = maximinAR1(Inp,optNCAR1loop,optNAR1loop);
        end    
        if valMMDVarRat == 1
            [NCmaxVarRat NmaxVarRat maxMinReVarRat] = maximinVarRat(Inp,optNCVarRatloop,optNVarRatloop);
        end    
        close(pobe_message)
        openfig('pobe_results_AR1var')
        hObject2 = pobe_results_AR1var;
        handles2 = guihandles(hObject2);

        if valMMDAR1 ==1 || valMMDVarRat == 1
            set(handles2.pushbuttonSaveMMD,'Enable','on')
        end    
        %selects axes1 as the current axes, so that 
        %Matlab knows where to plot the data
        axes(handles2.axes1)
        limNrLabels = 10; 
        x = Inp.minRho:0.01:Inp.maxRho;
        y = optNCAR1loop(1,:);

        [haxes,hline1,hline2]=plotyy(x,y,x,y); 
        set(hline1,'Color','k')
        set(hline2,'Color','k')

        
        axes(haxes(1));
        axis([Inp.minRho Inp.maxRho optNCAR1loop(1,1)-1 optNCAR1loop(1,end)+1])
        if size((optNCAR1loop(1,1)-1):(optNCAR1loop(1,end)+1))<=limNrLabels;
            set(gca,'YTick',(optNCAR1loop(1,1)-1):(optNCAR1loop(1,end)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optNCAR1loop(1,end)+1)-(optNCAR1loop(1,1)-1)+1)/limNrLabels);
            set(gca,'YTick',(optNCAR1loop(1,1)-1):betweenTickSize:(optNCAR1loop(1,end)+1),'FontUnits','normalized')
        end    
        set(gca,'XColor','k','YColor','k','FontUnits','normalized')
        xlabel('Autocorrelation parameter','Color','k','FontUnits','normalized');
        ylabel('Optimal number of cycles','Color','k','FontUnits','normalized');
        box off
        
        axes(haxes(2));
        axis([Inp.minRho Inp.maxRho optNCAR1loop(1,1)-1 optNCAR1loop(1,end)+1])
        set(gca,'XColor','k','YColor','k','FontUnits','normalized')
        ylabel('Time in minutes','Color','k','FontUnits','normalized')
        
        if Inp.blockorder == 1
            minTime = (optNCAR1loop(1,1)-1)*(Inp.Q*bla+bln)/60;
            maxTime = (optNCAR1loop(1,end)+1)*(Inp.Q*bla+bln)/60;
        else
            minTime = (optNCAR1loop(1,1)-1)*Inp.Q*(bla+bln)/60;
            maxTime = (optNCAR1loop(1,end)+1)*Inp.Q*(bla+bln)/60;
        end
        
        set(gca,'XTick',[]);
        if (floor(maxTime)-ceil(minTime)+1)< limNrLabels
            labely = ceil(minTime):1:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln),'FontUnits','normalized')
            else 
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)),'FontUnits','normalized')
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        else
            betweenTickSize = ceil((floor(maxTime)-ceil(minTime)+1)/limNrLabels);
            labely = ceil(minTime):betweenTickSize:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln),'FontUnits','normalized')
            else
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)),'FontUnits','normalized')
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        end    
        line([Inp.minRho Inp.maxRho],[(optNCAR1loop(1,end)+1) (optNCAR1loop(1,end)+1)]);
        
        axes(handles2.axes2)
        y=optNAR1loop(1,:);
        plot(x,y,'k')
        axis([Inp.minRho Inp.maxRho optNAR1loop(1,end)-1 optNAR1loop(1,1)+1])
        set(gca,'XColor','k','YColor','k')
        xlabel('Autocorrelation parameter','FontUnits','normalized')
        ylabel('Optimal number of subjects','FontUnits','normalized');
        if ((optNAR1loop(1,1)+1)-(optNAR1loop(1,end)-1)+1)<=limNrLabels
             set(gca,'YTick',(optNAR1loop(1,end)-1):1:(optNAR1loop(1,1)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optNAR1loop(1,1)+1)-(optNAR1loop(1,end)-1)+1)/limNrLabels);
            set(gca,'YTick',(optNAR1loop(1,end)-1):betweenTickSize:(optNAR1loop(1,1)+1),'FontUnits','normalized')
        end  
        
        axes(handles2.axes3)
        x = Inp.minVarRat:0.1:Inp.maxVarRat;
        y = optNCVarRatloop(1,:);
        [haxes,hline1,hline2]=plotyy(x,y,x,y);
        set(hline1,'Color','k')
        set(hline2,'Color','k')
        
        axes(haxes(1));
        axis([Inp.minVarRat Inp.maxVarRat optNCVarRatloop(1,1)-1 optNCVarRatloop(1,end)+1])
        if size((optNCVarRatloop(1,1)-1):(optNCVarRatloop(1,end)+1))<=limNrLabels;
            set(gca,'YTick',(optNCVarRatloop(1,1)-1):(optNCVarRatloop(1,end)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optNCVarRatloop(1,end)+1)-(optNCVarRatloop(1,1)-1)+1)/limNrLabels);
            set(gca,'YTick',(optNCVarRatloop(1,1)-1):betweenTickSize:(optNCVarRatloop(1,end)+1),'FontUnits','normalized')
        end    
        set(gca,'XColor','k','YColor','k','FontUnits','normalized')
        xlabel('Variance ratio','Color','k','FontUnits','normalized');
        ylabel('Optimal number of cycles','Color','k','FontUnits','normalized');
        box off
        
        axes(haxes(2));
        axis([Inp.minVarRat Inp.maxVarRat optNCVarRatloop(1,1)-1 optNCVarRatloop(1,end)+1])
        set(gca,'XColor','k','YColor','k','FontUnits','normalized')
        ylabel('Time in minutes','Color','k','FontUnits','normalized')
        
        if Inp.blockorder == 1
            minTime = (optNCVarRatloop(1,1)-1)*(Inp.Q*bla+bln)/60;
            maxTime = (optNCVarRatloop(1,end)+1)*(Inp.Q*bla+bln)/60;
        else
            minTime = (optNCVarRatloop(1,1)-1)*Inp.Q*(bla+bln)/60;
            maxTime = (optNCVarRatloop(1,end)+1)*Inp.Q*(bla+bln)/60;
        end
        
        set(gca,'XTick',[]);
        if (floor(maxTime)-ceil(minTime)+1)<limNrLabels
            labely = ceil(minTime):1:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln),'FontUnits','normalized') 
            else
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)),'FontUnits','normalized')
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        else
            betweenTickSize = ceil((floor(maxTime)-ceil(minTime)+1)/limNrLabels);
            labely = ceil(minTime):betweenTickSize:floor(maxTime);
            if Inp.blockorder == 1
                set(gca,'YTick',labely*60/(Inp.Q*bla+bln),'FontUnits','normalized')
            else
                set(gca,'YTick',labely*60/(Inp.Q*(bla+bln)),'FontUnits','normalized')
            end    
            set(gca,'YTickLabel',labely,'FontUnits','normalized');
        end    
        line([Inp.minVarRat Inp.maxVarRat],[(optNCVarRatloop(1,end)+1) (optNCVarRatloop(1,end)+1)]);
        
        axes(handles2.axes4)
        y=optNVarRatloop(1,:);
        plot(x,y,'k')
        axis([Inp.minVarRat Inp.maxVarRat optNVarRatloop(1,end)-1 optNVarRatloop(1,1)+1])
        xlabel('Variance ratio','FontUnits','normalized')
        ylabel('Optimal number of subjects','FontUnits','normalized');
        if size((optNVarRatloop(1,end)-1):(optNVarRatloop(1,1)+1))<=limNrLabels;
            set(gca,'YTick',(optNVarRatloop(1,end)-1):(optNVarRatloop(1,1)+1),'FontUnits','normalized')
        else
            betweenTickSize = ceil(((optNVarRatloop(1,1)+1)-(optNVarRatloop(1,end)-1)+1)/limNrLabels);
            set(gca,'YTick',(optNVarRatloop(1,end)-1):betweenTickSize:(optNVarRatloop(1,1)+1),'FontUnits','normalized')
        end  
        
        if valMMDAR1 == 1
            set(handles2.textMaxAR1NC,'String',NCmaxAR1);
            set(handles2.textMaxAR1N,'String',NmaxAR1);
             if Inp.blockorder == 1
                costs =NmaxAR1*Inp.C1+NmaxAR1*NCmaxAR1*Inp.C2/3600*(Inp.Q*bla+bln);
                time = NCmaxAR1*(Inp.Q*bla+bln)/60;
            else
                costs = NmaxAR1*Inp.C1+NmaxAR1*NCmaxAR1*Inp.C2/3600*Inp.Q*(bla+bln);
                time = NCmaxAR1*Inp.Q*(bla+bln)/60;   
            end    
            set(handles2.textResultsAR1costs,'String',costs);
            set(handles2.textResultsAR1time,'String',time);
            set(handles2.textResultsAR1MaxMinVal,'String',round(maxMinReAR1*10^4)/10^4);
        end 
        if valMMDVarRat == 1
            set(handles2.textMaxVarRatNC,'String',NCmaxVarRat);
            set(handles2.textMaxVarRatN,'String',NmaxVarRat);
            if Inp.blockorder == 1
                costs =NmaxVarRat*Inp.C1+NmaxVarRat*NCmaxVarRat*Inp.C2/3600*(Inp.Q*bla+bln);
                time = NCmaxVarRat*(Inp.Q*bla+bln)/60;
            else
                costs = NmaxVarRat*Inp.C1+NmaxVarRat*NCmaxVarRat*Inp.C2/3600*Inp.Q*(bla+bln);
                time = NCmaxVarRat*Inp.Q*(bla+bln)/60;   
            end  
            set(handles2.textResultsVarRatCosts,'String',costs);
            set(handles2.textResultsVarRatTime,'String',time);
            set(handles2.textResultsVarRatMaxMinVal,'String',round(maxMinReVarRat*10^4)/10^4);
        end   
        guidata(hObject, handles); %updates the handles
    case 5
        pobe_message;
        [optNCAR1VarRatloop optNAR1VarRatloop] = findOptNCandNAR1loopAR1VarRat(Inp);
        [NCmaxAR1VarRat NmaxAR1VarRat maxMinReAR1VarRat] = maximinAR1VarRat(Inp,optNCAR1VarRatloop,optNAR1VarRatloop);
        close(pobe_message)
        
        openfig('pobe_results_AR1var_sim')
        hObject2 = pobe_results_AR1var_sim;
        handles2 = guihandles(hObject2);
        
        set(handles2.textMaxNC,'String',NCmaxAR1VarRat);
        set(handles2.textMaxN,'String',NmaxAR1VarRat);
        if Inp.blockorder == 1
            costs =NmaxAR1VarRat*Inp.C1+NmaxAR1VarRat*NCmaxAR1VarRat*Inp.C2/3600*(Inp.Q*bla+bln);
            time = NCmaxAR1VarRat*(Inp.Q*bla+bln)/60;
        else
            costs = NmaxAR1VarRat*Inp.C1+NmaxAR1VarRat*NCmaxAR1VarRat*Inp.C2/3600*Inp.Q*(bla+bln);
            time = NCmaxAR1VarRat*Inp.Q*(bla+bln)/60;   
        end    
        %print(maxMinReAR1VarRat)
        set(handles2.textResultsCosts,'String',costs);
        set(handles2.textResultsTime,'String',time);
        set(handles2.textResultsMaxMinVal,'String',round(maxMinReAR1VarRat*10^4)/10^4); 
        guidata(hObject, handles); %updates the handles   
end    

function editNuisanceOrder_Callback(hObject, eventdata, handles)
% hObject    handle to editNuisanceOrder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNuisanceOrder as text
%        str2double(get(hObject,'String')) returns contents of editNuisanceOrder as a double
order = str2double(get(handles.editNuisanceOrder,'String'));
if isnan(order)||rem(order,1)~=0||(order<0)
    set(handles.editNuisanceOrder,'String','')
    uicontrol(handles.editNuisanceOrder)
    warndlg('Nuisance order must be a positive integer','Error','modal'); 
end 

% --- Executes during object creation, after setting all properties.
function editNuisanceOrder_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNuisanceOrder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupTypeNuisance.
function popupTypeNuisance_Callback(hObject, eventdata, handles)
% hObject    handle to popupTypeNuisance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupTypeNuisance contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupTypeNuisance


% --- Executes during object creation, after setting all properties.
function popupTypeNuisance_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupTypeNuisance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editVarRat_Callback(hObject, eventdata, handles)
% hObject    handle to editVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editVarRat as text
%        str2double(get(hObject,'String')) returns contents of editVarRat as a double
handles = guihandles(pobe);
handles2 = guidata(pobe);
varRat = str2double(get(handles.editVarRat,'String'));  
if isnan(varRat)||(varRat<=0)
    set(handles.editVarRat,'String','')
    uicontrol(handles.editVarRat);
    warndlg('Variance ratio must be a positive number and unequal to zero','Error','modal'); 
end 
if (get(handles.checkboxPower,'Value')) && isfield(handles,'wsv') && isfield(handles,'bsv')
    wsv = handles2.wsv;
    bsv = handles2.bsv;
    tol = 0.0001;
    if ~(abs(wsv/bsv - varRat)<tol)
        set(handles.editVarRat,'String','')
        uicontrol(handles.editVarRat);
        warndlg('Value for variance ratio does not agree with values for within-subject variance and between-subject variance from power menu','Error','modal')    
    end 
end
% --- Executes during object creation, after setting all properties.
function editVarRat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRho_Callback(hObject, eventdata, handles)
% hObject    handle to editRho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRho as text
%        str2double(get(hObject,'String')) returns contents of editRho as a double
rho = str2double(get(handles.editRho,'String'));
if isnan(rho)||(rho<0)||(rho>=1)
    set(handles.editRho,'String','')
    uicontrol(handles.editRho);
    warndlg('Autocorrelation must be number between 0 and 1','Error','modal'); 
 end
      

% --- Executes during object creation, after setting all properties.
function editRho_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function editScannerCosts_Callback(hObject, eventdata, handles)
% hObject    handle to editScannerCosts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editScannerCosts as text
%        str2double(get(hObject,'String')) returns contents of
%        editScannerCosts as a double
C2 = str2double(get(handles.editScannerCosts,'String'));
if isnan(C2)||(C2<=0)
    set(handles.editScannerCosts,'String','')
    uicontrol(handles.editScannerCosts)
    warndlg('Scanner costs must be a positive number and unequal to zero','Error','modal'); 
end 

% --- Executes during object creation, after setting all properties.
function editScannerCosts_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editScannerCosts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function editSubjectCosts_Callback(hObject, eventdata, handles)
% hObject    handle to editSubjectCosts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSubjectCosts as text
%        str2double(get(hObject,'String')) returns contents of editSubjectCosts as a double
C1 = str2double(get(handles.editSubjectCosts,'String'));
if isnan(C1)||(C1<=0)
    set(handles.editSubjectCosts,'String','')
    uicontrol(handles.editSubjectCosts)
    warndlg('Subjects costs must be a positive number and unequal to zero','Error','modal');  
end  

% --- Executes during object creation, after setting all properties.
function editSubjectCosts_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSubjectCosts (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function editTotalBudget_Callback(hObject, eventdata, handles)
% hObject    handle to editTotalBudget (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTotalBudget as text
%        str2double(get(hObject,'String')) returns contents of editTotalBudget as a double
CT = str2double(get(handles.editTotalBudget,'String'));
if isnan(CT)||(CT<=0)
    set(handles.editTotalBudget,'String','')
    uicontrol(handles.editTotalBudget)
    warndlg('Total study budget must be a positive number and unequal to zero','Error','modal'); 
end   

% --- Executes during object creation, after setting all properties.
function editTotalBudget_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTotalBudget (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function editTaskBlockLength_Callback(hObject, eventdata, handles)
% hObject    handle to editTaskBlockLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTaskBlockLength as text
%        str2double(get(hObject,'String')) returns contents of editTaskBlockLength as a double
bla = str2double(get(handles.editTaskBlockLength,'String'));
if isnan(bla)||(bla<=0)
    set(handles.editTaskBlockLength,'String','')
    uicontrol(handles.editTaskBlockLength)
    warndlg('Task block length must be a positive number and unequal to zero','Error','modal');  
end

% --- Executes during object creation, after setting all properties.
function editTaskBlockLength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTaskBlockLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editRestBlockLength_Callback(hObject, eventdata, handles)
% hObject    handle to editRestBlockLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRestBlockLength as text
%        str2double(get(hObject,'String')) returns contents of editRestBlockLength as a double
bln = str2double(get(handles.editRestBlockLength,'String'));
if isnan(bln)||(bln<0)
    set(handles.editRestBlockLength,'String','')
    uicontrol(handles.editRestBlockLength)
    warndlg('Rest block length must be a positive number','Error','modal');  
end    

% --- Executes during object creation, after setting all properties.
function editRestBlockLength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRestBlockLength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function editSOA_Callback(hObject, eventdata, handles)
% hObject    handle to editSOA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSOA as text
%        str2double(get(hObject,'String')) returns contents of editSOA as a double
SOA = str2double(get(handles.editSOA,'String'));
if isnan(SOA)||(SOA<=0)
    set(handles.editSOA,'String','')
    uicontrol(handles.editSOA)
    warndlg('Stimulus onset asynchrony must be a positive number and unequal to zero','Error','modal');
end 

% --- Executes during object creation, after setting all properties.
function editSOA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSOA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editTR_Callback(hObject, eventdata, handles)
% hObject    handle to editTR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editTR as text
%        str2double(get(hObject,'String')) returns contents of editTR as a
%        double
TR = str2double(get(handles.editTR,'String'));
if isnan(TR)||(TR<=0)
    set(handles.editTR,'String','')
    uicontrol(handles.editTR)
    warndlg('TR must be a positive number and unequal to zero','Error','modal');  
end   

% --- Executes during object creation, after setting all properties.
function editTR_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editTR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editNumberStimuli_Callback(hObject, eventdata, handles)
% hObject    handle to editNumberStimuli (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editNumberStimuli as text
%        str2double(get(hObject,'String')) returns contents of editNumberStimuli as a double
Q = str2double(get(handles.editNumberStimuli,'String'));
valOpt = get(handles.popupmenuOpt,'Value');
valContrast = get(handles.popupmenuContrastMatrix,'Value');
if isnan(Q)||rem(Q,1)~=0||(Q<=0)
    set(handles.editNumberStimuli,'String','')
    uicontrol(handles.editNumberStimuli)
    warndlg('Number of stimulus types must be a positive integer and unequal to zero','Error','modal');  
end    
if Q ==1 
    set(handles.editCorrRe,'Enable','Off')
    if get(handles.popupmenuRanges,'Value') == 1
        set(handles.checkboxPower,'Enable','On')
    end    
else
    set(handles.checkboxPower,'Enable','Off')
    set(handles.checkboxPower,'Value',0)
    if valOpt == 1 && valContrast == 1
        set(handles.editCorrRe,'Enable','Off')
    else
        set(handles.editCorrRe,'Enable','On')
    end   
end    

% --- Executes during object creation, after setting all properties.
function editNumberStimuli_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editNumberStimuli (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function editMinRho_Callback(hObject, eventdata, handles)
% hObject    handle to editMinRho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMinRho as text
%        str2double(get(hObject,'String')) returns contents of editMinRho
%        as a double
minRho = str2double(get(handles.editMinRho,'String'));
maxRho = str2double(get(handles.editMaxRho,'String'));
if isnan(minRho)||(minRho<0)||(minRho>=1)
    set(handles.editMinRho,'String','')
    uicontrol(handles.editMinRho)
    warndlg('Minimum value of autocorrelation must be number between 0 and 1','Error','modal'); 
end
if (minRho>=maxRho)
    warndlg('Minimum value higher than or equal to maximum value ','Error','modal'); 
end   
        
% --- Executes during object creation, after setting all properties.
function editMinRho_CreateFcn(hObject, ~, handles)
% hObject    handle to editMinRho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMaxRho_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxRho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxRho as text
%        str2double(get(hObject,'String')) returns contents of editMaxRho as a double
maxRho = str2double(get(handles.editMaxRho,'String'));
minRho = str2double(get(handles.editMinRho,'String'));
if isnan(maxRho)||(maxRho<0)||(maxRho>=1)
    set(handles.editMaxRho,'String','')
    uicontrol(handles.editMaxRho)
    warndlg('Maximum value of autocorrelation must be number between 0 and 1','Error','modal'); 
    return
end
if (minRho>=maxRho)
    warndlg('Minimum value higher than or equal to maximum value ','Error','modal'); 
end    

% --- Executes during object creation, after setting all properties.
function editMaxRho_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxRho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMinVarRat_Callback(hObject, eventdata, handles)
% hObject    handle to editMinVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMinVarRat as text
%        str2double(get(hObject,'String')) returns contents of editMinVarRat as a double
minVarRat = str2double(get(handles.editMinVarRat,'String'));
maxVarRat = str2double(get(handles.editMaxVarRat,'String'));
if isnan(minVarRat)||(minVarRat<0)
    set(handles.editMinVarRat,'String','')
    uicontrol(handles.editMinVarRat)
    warndlg('Minimum value of variance ratio must be positive number','Error','modal'); 
end
if (maxVarRat<=minVarRat)
    warndlg('Minimum value higher than or equal to maximum value','Error','modal'); 
end

% --- Executes during object creation, after setting all properties.
function editMinVarRat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMinVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMaxVarRat_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxVarRat as text
%        str2double(get(hObject,'String')) returns contents of editMaxVarRat as a double
maxVarRat = str2double(get(handles.editMaxVarRat,'String'));
minVarRat = str2double(get(handles.editMinVarRat,'String'));
if isnan(maxVarRat)||(maxVarRat<0)
    set(handles.editMaxVarRat,'String','')
    uicontrol(handles.editMaxVarRat);
    warndlg('Maximum value of variance ratio must be a positive number','Error','modal'); 
    return
end
if (maxVarRat<=minVarRat)
    warndlg('Minimum value higher than or equal to maximum value','Error','modal'); 
end

% --- Executes during object creation, after setting all properties.
function editMaxVarRat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxModelNuisance.
function checkboxModelNuisance_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxModelNuisance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxModelNuisance
handles = guihandles(hObject);
val = get(hObject,'Value');
if val == 0
    set(handles.editNuisanceOrder,'Enable','off')
    set(handles.popupTypeNuisance,'Enable','off')
else 
    set(handles.editNuisanceOrder,'Enable','on')
    set(handles.popupTypeNuisance,'Enable','on')
end     

% --- Executes on selection change in popupmenuRanges.
function popupmenuRanges_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuRanges (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuRanges contents as cell array
%        contents{get(hObject,'Value')} returns selected item from
%        popupmenuRanges
handles = guihandles(hObject);
handles2 = guihandles(pobe);
val = get(hObject,'Value');
valPrevious = get(handles2.popupmenuPreviousStudy,'Value');
if valPrevious == 2 && val == 2
    val = 3;
end    
switch val
    case 1 
        set(handles.editRho,'Enable','on')
        set(handles.editVarRat,'Enable','on')
        set(handles.editMinRho,'Enable','off')
        set(handles.editMaxRho,'Enable','off')
        set(handles.editMinVarRat,'Enable','off')
        set(handles.editMaxVarRat,'Enable','off')
        set(handles.checkboxMMDAR1,'Enable','off')
        set(handles.checkboxMMDAR1,'Value',0)
        set(handles.checkboxMMDVarRat,'Enable','off')
        set(handles.checkboxMMDVarRat,'Value',0)
        if str2double(get(handles.editNumberStimuli,'String')) == 1
          if not(isfield(handles,'C')) || size(handles.C,1) == 1
            set(handles.checkboxPower,'Enable','on')  
          end  
        end  
    case 2   
        set(handles.editRho,'Enable','off')
        set(handles.editVarRat,'Enable','on')
        set(handles.editMinRho,'Enable','on')
        set(handles.editMaxRho,'Enable','on')
        set(handles.editMinVarRat,'Enable','off')
        set(handles.editMaxVarRat,'Enable','off')
        set(handles.checkboxMMDAR1,'Enable','on')
        set(handles.checkboxMMDVarRat,'Enable','off')
        set(handles.checkboxMMDVarRat,'Value',0)
        set(handles.checkboxPower,'Enable','off') 
        set(handles.checkboxPower,'Value',0)
    case 3   
        set(handles.editRho,'Enable','on')
        set(handles.editVarRat,'Enable','off')
        set(handles.editMinRho,'Enable','off')
        set(handles.editMaxRho,'Enable','off')
        set(handles.editMinVarRat,'Enable','on')
        set(handles.editMaxVarRat,'Enable','on')
        set(handles.checkboxMMDAR1,'Enable','off')
        set(handles.checkboxMMDAR1,'Value',0)
        set(handles.checkboxMMDVarRat,'Enable','on')
        set(handles.checkboxPower,'Enable','off') 
        set(handles.checkboxPower,'Value',0)
    case 4   
        set(handles.editRho,'Enable','on')
        set(handles.editVarRat,'Enable','on')
        set(handles.editMinRho,'Enable','on')
        set(handles.editMaxRho,'Enable','on')
        set(handles.editMinVarRat,'Enable','on')
        set(handles.editMaxVarRat,'Enable','on')
        set(handles.checkboxMMDAR1,'Enable','on')
        set(handles.checkboxMMDVarRat,'Enable','on')
        set(handles.checkboxPower,'Enable','off') 
        set(handles.checkboxPower,'Value',0)
    case 5    
        set(handles.editRho,'Enable','off')
        set(handles.editVarRat,'Enable','off')
        set(handles.editMinRho,'Enable','on')
        set(handles.editMaxRho,'Enable','on')
        set(handles.editMinVarRat,'Enable','on')
        set(handles.editMaxVarRat,'Enable','on')
        set(handles.checkboxMMDAR1,'Enable','off')
        set(handles.checkboxMMDAR1,'Value',0)
        set(handles.checkboxMMDVarRat,'Enable','off')
        set(handles.checkboxMMDVarRat,'Value',0)
        set(handles.checkboxPower,'Enable','off') 
        set(handles.checkboxPower,'Value',0)
end        
if valPrevious == 2
    set(handles.editRho,'Enable','off')
    set(handles.editMinRho,'Enable','off')
    set(handles.editMaxRho,'Enable','off')
end            
        
% --- Executes during object creation, after setting all properties.
function popupmenuRanges_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuRanges (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on key press with focus on checkboxModelNuisance and none of its controls.
function checkboxModelNuisance_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to checkboxModelNuisance (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkboxMMDAR1.
function checkboxMMDAR1_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxMMDAR1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxMMDAR1

% --- Executes on button press in checkboxMMDVarRat.
function checkboxMMDVarRat_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxMMDVarRat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxMMDVarRat


function editCorrRe_Callback(hObject, eventdata, handles)
% hObject    handle to editCorrRe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editCorrRe as text
%        str2double(get(hObject,'String')) returns contents of editCorrRe as a double
corrRE = str2double(get(handles.editCorrRe,'String'));
if isnan(corrRE)||(abs(corrRE)>=1)
    set(handles.editCorrRe,'String','')
    uicontrol(handles.editCorrRe);
    warndlg('Correlation between random effects must be number between -1 and 1','Error','modal'); 
end

% --- Executes during object creation, after setting all properties.
function editCorrRe_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCorrRe (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in popupmenuContrastMatrix.
function popupmenuContrastMatrix_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuContrastMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuContrastMatrix contents as cell array
%        contents{get(hObject,'Value')} returns selected item from
%        popupmenuContrastMatrix
valContrast = get(hObject,'Value');
valOpt = get(handles.popupmenuOpt,'Value');
Q = str2double(get(handles.editNumberStimuli,'String'));
if valContrast == 1
    close(findobj('type','figure','name','POBE 1.2: enter contrast matrix'));
else
    close(findobj('type','figure','name','POBE 1.2: enter contrast matrix'));
    openfig('pobe_enter');
end
if (Q==1)
    set(handles.editCorrRe,'Enable','Off')
else    
    if valContrast == 1 && valOpt == 1
        set(handles.editCorrRe,'Enable','Off')
    else
        set(handles.editCorrRe,'Enable','On')
    end   
end

   
% --- Executes during object creation, after setting all properties.
function popupmenuContrastMatrix_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuContrastMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function DesignPanel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DesignPanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on selection change in popupmenuBlockOrder.
function popupmenuBlockOrder_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuBlockOrder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuBlockOrder contents as cell array
%        contents{get(hObject,'Value')} returns selected item from
%        popupmenuBlockOrder

% --- Executes during object creation, after setting all properties.
function popupmenuBlockOrder_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuBlockOrder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonReset.
function pushbuttonReset_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonReset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ans_reset=questdlg('Do you  want to reset the given values?','Reset','Yes','No','No');
if strcmp(ans_reset,'No')
    return;
end   
clear all; close all; pobe;

% --- Executes on button press in pushbuttonExit.
function pushbuttonExit_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonExit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ans_exit=questdlg('Do you want to exit the program?','Exit','Yes','No','No');
if strcmp(ans_exit,'No')
    return;
end
clear, clc, close all

% --- Executes on button press in pushbuttonHelp.
function pushbuttonHelp_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonHelp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
helpdlg('Please refer to available documentation for more information.','Help')


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in popupmenuHRF.
function popupmenuHRF_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuHRF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuHRF contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuHRF
valHRF = get(hObject,'Value');

if valHRF == 1
    close(findobj('type','figure','name','POBE 1.2: specify HRF parameters'));
else
    close(findobj('type','figure','name','POBE 1.2: specify HRF parameters'));
    openfig('pobe_specify_HRF');
end


% --- Executes during object creation, after setting all properties.
function popupmenuHRF_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuHRF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxPower.
function checkboxPower_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxPower (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guihandles(pobe);
% Hint: get(hObject,'Value') returns toggle state of checkboxPower
value = get(hObject,'Value');
if value == 1;
    close(findobj('type','figure','name','POBE 1.2: power calculation'));
    openfig('pobe_power');
else
    close(findobj('type','figure','name','POBE 1.2: power calculation'));
    if isfield(handles,'effectSize')
        clear(handles.effectSize)
    end
    if isfield(handles,'wsv')
        clear(handles.wsv)
    end
    if isfield(handles,'bsv')
        clear(handles.bsv)
    end
    if isfield(handles,'alpha')
        clear(handles.alpha)
    end
    guidata(pobe,handles)
end


% --- Executes on selection change in popupmenuOpt.
function popupmenuOpt_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuOpt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuOpt contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuOpt
valContrast = get(handles.popupmenuContrastMatrix,'Value');
valOpt = get(handles.popupmenuOpt,'Value');
Q = str2double(get(handles.editNumberStimuli,'String'));
if (Q==1)
    set(handles.editCorrRe,'Enable','Off')
else    
    if valContrast == 1 && valOpt == 1
        set(handles.editCorrRe,'Enable','Off')
    else
        set(handles.editCorrRe,'Enable','On')
    end   
end

% --- Executes during object creation, after setting all properties.
function popupmenuOpt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuOpt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuPreviousStudy.
function popupmenuPreviousStudy_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuPreviousStudy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenuPreviousStudy contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuPreviousStudy
PreviousVal = get(handles.popupmenuPreviousStudy,'Value');
valRanges = get(handles.popupmenuRanges,'Value');
if PreviousVal == 2
    set(handles.popupmenuRanges,'Value',1)
    set(handles.editRho,'Enable','Off')
    set(handles.editRho,'String','')
    set(handles.editMinRho,'Enable','Off')
    set(handles.editMaxRho,'Enable','Off')
    
    %change popupmenuRanges
    set(handles.popupmenuRanges,'String',strvcat('Fixed values (no ranges)','Range for ratio (correlation fixed)'))
else
    set(handles.popupmenuRanges,'String',strvcat('Fixed values (no ranges)',...
    'Range for correlation (ratio fixed)',...
    'Range for ratio (correlation fixed)',...
    'Range for correlation (ratio fixed) and ratio (correlation fixed)',...
    'Range for correlation and ratio (nothing fixed)'))
    set(handles.popupmenuRanges,'Value',1)
    popupmenuRanges_Callback(handles.popupmenuRanges)
end    
get(handles.popupmenuContrastMatrix,'Value');

% --- Executes during object creation, after setting all properties.
function popupmenuPreviousStudy_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuPreviousStudy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
