function varargout = pobe_enter(varargin)
%pobe_enter M-file for pobe_enter.fig
%      pobe_enter, by itself, creates a new pobe_enter or raises the existing
%      singleton*.
%
%      H = pobe_enter returns the handle to a new pobe_enter or the handle to
%      the existing singleton*.
%
%      pobe_enter('Property','Value',...) creates a new pobe_enter using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to pobe_enter_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      pobe_enter('CALLBACK') and pobe_enter('CALLBACK',hObject,...) call the
%      local function named CALLBACK in pobe_enter.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help pobe_enter

% Last Modified by GUIDE v2.5 29-Aug-2011 16:16:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @pobe_enter_OpeningFcn, ...
                   'gui_OutputFcn',  @pobe_enter_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before pobe_enter is made visible.
function pobe_enter_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for pobe_enter
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes pobe_enter wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = pobe_enter_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function editMatrix_Callback(hObject, eventdata, handles)
% hObject    handle to editMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMatrix as text
%        str2double(get(hObject,'String')) returns contents of editMatrix as a double


% --- Executes during object creation, after setting all properties.
function editMatrix_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbuttonSave.
function pushbuttonSave_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%global C
handles2 = guihandles(hObject);
C = str2num(get(handles2.editMatrix,'String'));
handles = guihandles(pobe);
Q = get(handles.editNumberStimuli,'String');
if not(strcmp(Q,''))&& size(C,2)~=str2double(Q)
    warndlg('Number of stimulus types is unequal to number of columns in contrast matrix or no matrix has been specified','Error','modal');
    pobe_enter;
else
    handles.C = C;
    if size(handles.C,1)==1 && get(handles.popupmenuRanges,'Value')==1
        set(handles.checkboxPower,'Enable','On')
    else
        set(handles.checkboxPower,'Enable','Off')
        set(handles.checkboxPower,'Value',0)
    end    
    guidata(pobe,handles);
    close(findobj('type','figure','name','POBE 1.2: enter contrast matrix'));
    pobe;
end

% --- Executes on button press in pushbuttonReset.
function pushbuttonReset_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonReset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ans_reset=questdlg('Do you  want to reset the given values?','Reset','Yes','No','Yes');
handles = guihandles(hObject);
if strcmp(ans_reset,'No')
    return;
else
    set(handles.editMatrix,'String','')
end    


% --- Executes on button press in pushbuttonCancel.
function pushbuttonCancel_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonCancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(findobj('type','figure','name','POBE 1.2: enter contrast matrix'));
handles2 = guihandles(pobe);
set(handles2.popupmenuContrastMatrix,'Value',1)
if isfield(handles2,'C')
    clear(handles2.C)
end    
guidata(pobe,handles2)
pobe;


% --- Executes on button press in pushbuttonHelp.
function pushbuttonHelp_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonHelp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
helpdlg('Please enter the contrast matrix. The number of rows of the contrast matrix is equal to the number of contrasts since each row of the contrast matrix specifies one contrast. Use the enter key to specify the different rows/contrasts. In one row enter the entries of the contrasts and separate them by a blank space. Example 1: 1 -1. Example 2: 0 1 -1 0.','Help')
