function varargout = pobe_results(varargin)
% pobe_results M-file for pobe_results.fig
%      pobe_results, by itself, creates a new pobe_results or raises the existing
%      singleton*.
%
%      H = pobe_results returns the handle to a new pobe_results or the handle to
%      the existing singleton*.
%
%      pobe_results('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in pobe_results.M with the given input arguments.
%
%      pobe_results('Property','Value',...) creates a new pobe_results or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before pobe_results_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to pobe_results_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help pobe_results

% Last Modified by GUIDE v2.5 23-Sep-2012 21:48:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @pobe_results_OpeningFcn, ...
                   'gui_OutputFcn',  @pobe_results_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before pobe_results is made visible.
function pobe_results_OpeningFcn(hObject, eventdata, handles, varargin)

% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to pobe_results (see VARARGIN)

% Choose default command line output for pobe_results
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes pobe_results wait for user response (see UIRESUME)
% uiwait(handles.pobe_results);


% --- Outputs from this function are returned to the command line.
function varargout = pobe_results_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbuttonSave.
function pushbuttonSave_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
hObject2 = pobe;
handles2 = guidata(hObject2);

%file name
date = clock;
date = [num2str(date(3))  num2str(date(2))  num2str(date(1)) '-' num2str(date(4))  num2str(date(5)) ];
nameFile = strcat('Results',date);

%preparing input 
namesInp = {get(handles2.textTaskBlockLength,'String');...
    get(handles2.textRestBlockLength,'String');...
    get(handles2.textSOA,'String');get(handles2.textTR,'String');...
    get(handles2.textNumberStimuli,'String');get(handles2.textBlockOrder,'String');'Optimality criterion';get(handles2.textSubjectCosts,'String');...
    get(handles2.textScannerCosts,'String');get(handles2.textTotalBudget,'String');...
    'HRF'};

%HRF
if handles2.valHRF == 2
    namesInp = [namesInp;'Shape';'Time to peak';'Time to undershoot';'Positive to negative ratio';...
        'Positive dispersion';'Negative dispersion';'Onset of HRF';'Minimum of HRF sampling range';...
        'Maximum of HRF sampling range';'Scaling parameter (nonlinearity)'];
end
namesInp = [namesInp;get(handles2.textRho,'String');get(handles2.textVarRat,'String');...
        get(handles2.textCorrRe,'String');get(handles2.textTypeNuisance,'String');...
        get(handles2.textNuisanceOrder,'String')];

if get(handles2.checkboxPower,'Value') == 1
    namesInp=[namesInp;'Effect size';'Within-subject variance';'Between-subject variance';...
        'Significance level (Type I error)'];
end

nuisanceBool = get(handles2.checkboxModelNuisance,'Value');
if nuisanceBool == 1
    valNuisance = get(handles2.popupTypeNuisance,'Value');
    if valNuisance == 1
        type = 'Legendre';
    else
        type = 'Discrete cosine transforms';
    end   
    order = str2double(get(handles2.editNuisanceOrder,'String'));
else
    type = 'Legendre';
    order = 0;
end

blockorder = get(handles2.popupmenuBlockOrder,'Value');
if blockorder == 1
    blockorder = 'ABN';
else
    blockorder = 'ANBN';
end

optCrit = get(handles2.popupmenuBlockOrder,'Value');
if optCrit == 1
    optCrit = 'A-optimality criterion';
else
    optCrit = 'D-optimality criterion';
end

if handles2.valHRF == 1
    hrfUsed = 'Standard HRF (double gamma)';
else
    hrfUsed = 'User specified HRF';
end

valuesInp = {get(handles2.editTaskBlockLength,'String');get(handles2.editRestBlockLength,'String');...
get(handles2.editSOA,'String');get(handles2.editTR,'String');get(handles2.editNumberStimuli,'String');...
blockorder;optCrit;get(handles2.editSubjectCosts,'String');get(handles2.editScannerCosts,'String');...
get(handles2.editTotalBudget,'String');hrfUsed};

%HRF
if handles2.valHRF == 2
    if handles2.shape==1
        shape = 'Double gamma';
    else
        shape = 'Boynton';
    end  
  
    valuesInp = {valuesInp{:,1} shape handles2.TTP handles2.TTU handles2.ratio handles2.posDisp ...
        handles2.negDisp handles2.onset handles2.minRange handles2.maxRange handles2.scale}';
end   

%rest
valPreviousAuto = get(handles2.popupmenuPreviousStudy,'Value');
if valPreviousAuto == 1
    valuesInp = {valuesInp{:,1} get(handles2.editRho,'String') get(handles2.editVarRat,'String') ...
    get(handles2.editCorrRe,'String') type order}';
else 
    valuesInp = {valuesInp{:,1} 'Previous Study' get(handles2.editVarRat,'String') ...
    get(handles2.editCorrRe,'String') type order}';
end
if get(handles2.checkboxPower,'Value') == 1
    valuesInp={valuesInp{:,1} handles2.effectSize handles2.wsv handles2.bsv handles2.alpha}';
end

%writing Input into excel file
xlswrite(nameFile,{'INPUT'},1,'A1');
xlswrite(nameFile,[namesInp valuesInp],1,'A2');
xlswrite(nameFile,{'Matrix C'},1,'D2');
xlswrite(nameFile,handles2.C,1,'D3');

%preparing results
valuesResults = {get(handles.textResultsSubjects,'String');get(handles.textResultsCycles,'String');get(handles.textResultsCosts,'String');...
    get(handles.textResultsTime,'String');get(handles.textResultsPower,'String')};
namesResults = {get(handles.textOptimalNrSubjects,'String');...
    get(handles.textOptimalNrCycles,'String');...
    get(handles.textCosts,'String');...
    get(handles.textTime,'String');...
    get(handles.textPower,'String')};
cellResults = strcat('A',num2str(size(namesInp,1)+3));

%writing results
xlswrite(nameFile,{'RESULTS'},1,cellResults);
cellResults = strcat('A',num2str(size(namesInp,1)+4));
xlswrite(nameFile,[namesResults valuesResults],1,cellResults);

%to autofit columns?
e=actxserver('excel.application');
eW=e.Workbooks;
eF=eW.Open(strcat(pwd,'\',nameFile)); % your filename here
eS=eF.ActiveSheet;
eS.Range('A1').EntireColumn.AutoFit; % autofit column A
eS.Range('B1').EntireColumn.AutoFit; % autofit column B
%eS.Range('A1').EntireColumn.Font.Name = 'Times'; % changes font to Times 
eF.Save;
eF.Close
