function s = zsz(sz)
% zsz  - returns zeros(size(svzar))
%
% FORMAT:       zerosws = zsz(anyvar)
%
% Input fields:
%
%       anyvar      any variable
%
% Output fields
%
%       zerosws     zeros with size of input argument
%
% See also osz

% Version:  v0.7f
% Build:    8110521
% Date:     Nov-05 2008, 9:00 PM CET
% Author:   Jochen Weber, SCAN Unit, Columbia University, NYC, NY, USA
% URL/Info: http://wiki.brainvoyager.com/BVQXtools

% argument check
if nargin ~= 1
    error( ....
        'BVQXtools:BadArgument', ...
        'Function zsz requires exactly one argument.' ...
    );
end

% create zeros array with correct size
s = zeros(size(sz));
